<?php 
class InsertQuery
{
    private $field = array();
    public $tableName = '';
    public $dbPrefix = ''; 
    
    function add($name, $value, $string = false)
    {
        if( !is_numeric($value) || $string ) $value = '\''.addslashes($value).'\'';
        $this->field['`'.$name.'`'] = $value;    
    }
    
    function reset()
    {
        $this->field = array();
    }
    
    function getSQL()
    {
        $tableName = $this->dbPrefix ? $this->dbPrefix.$this->tableName : $this->tableName;
        
        $sql = 'insert into `'.$tableName.'`('.implode(',',array_keys($this->field)).') values('.implode(',',array_values($this->field)).');';
        return $sql;
    }

}

class Converter
{
    public $dbOldHost;
    public $dbOldName;
    public $dbOldUser;
    public $dbOldPass;
    public $dbOldPrefix = '';
    
    public $dbNewHost;
    public $dbNewName;
    public $dbNewUser;
    public $dbNewPass;
    public $dbNewPrefix = '';
    
    protected $qObiect;
    protected $dbOld = null;
    protected $dbNew = null;
    
    function query($sql, $dbInstance)
    {
        //echo htmlspecialchars($sql).'<br />';
        $result = mysql_query($sql , $dbInstance);
        
        if($result === false)
        {
            throw new Exception(mysql_error());
        }
        
        return $result;
    }
    
    function setOldDb()
    {
         $this->query( 'set names \'latin1\';' , $this->dbOld );
         $this->query( 'set charset \'latin1\';' , $this->dbOld );
        
         $this->query( 'use '.$this->dbOldName.';' , $this->dbOld );    
    }
    
    function setNewDb()
    {                                     
         $this->query( 'set names \'latin1\';' , $this->dbNew );
         //$this->query( 'set charset \'latin1\';' , $this->dbNew );
         
         $this->query( 'use '.$this->dbNewName.';' , $this->dbNew );    
    }
    
    function addCategoryParentNode($parentId, $childId) 
    {     
        $result = $this->query( 'select parentId, depth from `'.$this->dbNewPrefix.'categoryparents` WHERE categoryId=\''.$parentId.'\'' , $this->dbNew); 

        $maxDepth = 0;
        $categoryParents = array();
        
        while($r = mysql_fetch_assoc($result)) 
        {        
            $categoryParents[] = array('parentId'   => $r['parentId'],
                                       'categoryId' => $childId,
                                       'depth'      => $r['depth'] + 1);
            
            $maxDepth = max($maxDepth, $r['depth']);
        }
        
        if(!$maxDepth)
        {
            $categoryParents[] = array('parentId'   => 0,
                                       'categoryId' => $childId,
                                       'depth'      => 1);
        }
        
        $categoryParents[] = array('parentId'   => $childId,
                                   'categoryId' => $childId,
                                   'depth'      => 0);  
        
        $this->qObiect->tableName = 'categoryparents';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
        
        foreach($categoryParents as $categoryParent)
        { 
            $this->qObiect->reset();
            $this->qObiect->add('parentId', $categoryParent['parentId']);
            $this->qObiect->add('categoryId', $categoryParent['categoryId']); 
            $this->qObiect->add('depth', $categoryParent['depth']); 
            
            $sql = $this->qObiect->getSQL();
            $this->query($sql, $this->dbNew);
        }
    }
    
    function buildCategoryParents()
    {
        $this->query( 'delete from `'.$this->dbNewPrefix.'categoryparents`', $this->dbNew); 
        $result = $this->query( 'select categoryId, parentCategoryId from `'.$this->dbNewPrefix.'categories` ORDER BY parentCategoryId' , $this->dbNew); 
        
        while($r = mysql_fetch_assoc($result)) 
        {        
            $this->addCategoryParentNode($r['parentCategoryId'], $r['categoryId']);
        }    
        
        $sql = "UPDATE ".$this->dbNewPrefix."categories SET validatedSitesCount = ( SELECT count( * ) 
                FROM ".$this->dbNewPrefix."sites, ".$this->dbNewPrefix."categoryparents 
                WHERE status = 'validated'  
                AND ".$this->dbNewPrefix."categoryparents.parentId = ".$this->dbNewPrefix."categories.categoryId 
                AND ".$this->dbNewPrefix."categoryparents.categoryId = ".$this->dbNewPrefix."sites.categoryId)";
                
        $this->query($sql, $this->dbNew);
                
    } 

    function init()
    {
        $this->qObiect = new InsertQuery;

        $this->dbOld = @mysql_connect($this->dbOldHost, $this->dbOldUser, $this->dbOldPass);
        
        if($this->dbOld === false)
        {
            throw new Exception(mysql_error());
        }
        
        $this->dbNew = @mysql_connect($this->dbNewHost, $this->dbNewUser, $this->dbNewPass);
        
        if($this->dbNew === false)
        {
            throw new Exception(mysql_error());
        }  

        $this->setOldDb();
        $this->setNewDb();
    }
}



?>
