<?php

class FractalumConverter extends Converter
{   
    private static $handle = null;
    
    function getInstance()
    {
        if( !self::$handle ) self::$handle = new FractalumConverter;
        return self::$handle;
    }

    function convertSites()
    {        
        $this->setOldDb();
        $result = $this->query( 'select * from `frac_moteur`;' , $this->dbOld );
        /*nom 	url 	actif 	description 	email 	mot 	cat 	root 	compt_in 	compt_out 	id 	langue 	star 	date_inser 	nb_com 	awards*/
        
        $this->setNewDb();
        
        $this->query( 'delete from `'.$this->dbNewPrefix.'sites`;' , $this->dbNew );

        /* extra things*/
        $this->query( 'delete from `'.$this->dbNewPrefix.'votes`;' , $this->dbNew );
        $this->query( 'delete from `'.$this->dbNewPrefix.'comments`;' , $this->dbNew );
        /*             */
        
        $this->qObiect->tableName = 'sites';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
        while( $r = mysql_fetch_assoc($result) )
        {
                $this->qObiect->reset();
            
                $this->qObiect->add('siteId', $r['id_moteur']);
                $this->qObiect->add('categoryId', $r['id_categorie']);
                $this->qObiect->add('siteTitle', $r['titre']);
                $this->qObiect->add('description', strip_tags($r['commentaire']));
                $this->qObiect->add('url', $r['site']);
                
                $this->qObiect->add('webmasterEmail', $r['email']);
                $this->qObiect->add('creationDate', $r['date']);
                
                if($r['valid'])
                {
                    $status = 'validated';
                }
                else
                {
                    $status = 'waiting';
                }
                //proposalForKeywords
                $this->qObiect->add('status', $status);
                $this->qObiect->add('visitsCount', 0);
                $this->qObiect->add('rssTitle', '');
                $this->qObiect->add('returnBond', '');
                $this->qObiect->add('rssFeedOfSite', '');

                $sql = $this->qObiect->getSQL();
                $sql = iconv('ISO-8859-1','utf-8//ignore', $sql);
                $sql = str_replace("\xc2\x80", "\xe2\x82\xac", $sql); 
                $this->query($sql , $this->dbNew);
        }
        
        return true;
    }

    function convertCategories()
    {        
        $this->setOldDb();
        $result = $this->query( 'select * from `frac_categorie`;' , $this->dbOld );
        /*nom 	attach 	id 	chemin 	description 	actif 	nb_site 	im 	sous_cat 	aff_parent 	colonne 	nb_cat 	nb_tot 	id_advertise 	back_url_rewriting*/
        
        $this->setNewDb();
        $this->query( 'delete from `'.$this->dbNewPrefix.'categories`;' , $this->dbNew );
        
        $this->qObiect->tableName = 'categories';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
       
        while( $r = mysql_fetch_assoc($result) )
        {
            $this->qObiect->reset();
            
            $this->qObiect->add('categoryId', $r['id_categorie']);
            $this->qObiect->add('parentCategoryId', $r['pere_id']);
            $this->qObiect->add('name', $r['categorie']);
            $this->qObiect->add('description', '');
            $this->qObiect->add('imageSrc', 'defaultCategoryImage.gif');
            $this->qObiect->add('possibleTender', 1, true);
            $this->qObiect->add('title', '');
            
            $sql = $this->qObiect->getSQL();
            $sql = iconv('ISO-8859-1', 'utf-8//ignore', $sql);
            $sql = str_replace("\xc2\x80", "\xe2\x82\xac", $sql); 
            $this->query($sql , $this->dbNew);
        }
        
        return true;
    }

    function convertAll()
    {     
        $results = array();
                    
        try
        {
            $results['sites'] = array();
            $this->init();
            $this->convertSites();
            
            $results['categories'] = array();  
            $this->convertCategories();
            $this->buildCategoryParents();
        }
        catch(Exception $e)
        {
            $lastKey = end(array_keys($results));
            $results[$lastKey]['error'] = $e->getMessage();
        }
        
        return $results;
    }
}
?>