<?php 

class FreeglobesConverter extends Converter
{
    private static $handle = null;
    
    function getInstance()
    {
        if( !self::$handle ) self::$handle = new FreeglobesConverter;
        return self::$handle;
    }
    
    function convertUsers() 
    {        
        $this->setOldDb();
        $result = $this->query( 'select * from `'.$this->dbOldPrefix.'user`;' , $this->dbOld );
        /*id 	login 	pass 	email 	active 	isadmin 	points*/
        
        $this->setNewDb();
        $this->query( 'delete from `'.$this->dbNewPrefix.'users`;' , $this->dbNew );

        $this->query( 'alter table `'.$this->dbNewPrefix.'users` modify `email` varchar(100);' , $this->dbNew );
        
        $this->qObiect->tableName = 'users';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
        
        while( $r = mysql_fetch_assoc( $result ) )
        {
                $this->qObiect->reset();
            
                $this->qObiect->add('userId', $r['id']);
                $this->qObiect->add('login', $r['login']);
                $this->qObiect->add('password', $r['pass']);
                $this->qObiect->add('email', $r['email']);
                
                if( $r['isadmin'] ) $this->qObiect->add('role','administrator');
                else $this->qObiect->add('role','webmaster');  
             
                $sql = $this->qObiect->getSQL();
                $sql = iconv('ISO-8859-1','utf-8//ignore',$sql);
                $sql = str_replace("\xc2\x80", "\xe2\x82\xac", $sql); 
                $this->query( $sql , $this->dbNew );
        }
        
        return true;
    }

    function convertSites()
    {        
        $this->setOldDb();
        $result = $this->query( 'select * from `'.$this->dbOldPrefix.'link`;' , $this->dbOld );
        /* id 	uid 	name 	url 	description 	state 	category 	pr 	image 	hits 	prio 	vote 	broken 	email 	date */
        $this->setNewDb();
        
        $this->query( 'delete from `'.$this->dbNewPrefix.'sites`;' , $this->dbNew );
        $this->query( 'alter table `'.$this->dbNewPrefix.'sites` modify `imageSrc` varchar(200);' , $this->dbNew );
     
        $this->query( 'delete from `'.$this->dbNewPrefix.'votes`;' , $this->dbNew );
        $this->query( 'delete from `'.$this->dbNewPrefix.'comments`;' , $this->dbNew );
   
        
        $this->qObiect->tableName = 'sites';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
        
        while( $r = mysql_fetch_assoc($result) )
        {
                $this->qObiect->reset();
            
                $this->qObiect->add('siteId', $r['id']);               
                $this->qObiect->add('categoryId', $r['category']);
                $this->qObiect->add('siteTitle', html_entity_decode(strip_tags($r['name']), ENT_QUOTES));
                $this->qObiect->add('description', html_entity_decode(strip_tags($r['description']), ENT_QUOTES));
                $this->qObiect->add('url', $r['url']);
                $this->qObiect->add('webmasterEmail', $r['email']);
                
                $r['date'] = str_replace('-', '', $r['date']);
                $this->qObiect->add('creationDate', $r['date'].'000000');
                
                switch($r['state'])
                {
                    case 4:
                        $status = 'validated';
                    break;
                    case 2:
                        $status = 'banned';
                    break;
                    default: //state 1 = waiting
                        $status = 'waiting';
                    break;
                    
                
                }
                
                $this->qObiect->add('status', $status);
                $this->qObiect->add('visitsCount', $r['hits']);
                $this->qObiect->add('priority', $r['prio']);
                $this->qObiect->add('webmasterId', $r['uid']);
                $this->qObiect->add('rssTitle', '');
                $this->qObiect->add('returnBond', '');
                $this->qObiect->add('rssFeedOfSite', '');

                $sql = $this->qObiect->getSQL();
                
                $sql = iconv('ISO-8859-1','utf-8//ignore',$sql);
                $sql = str_replace("\xc2\x80", "\xe2\x82\xac", $sql); 
                
                $this->query( $sql , $this->dbNew );
        }
        
        return true;
    }

    function convertCategories()
    {        
        $this->setOldDb();
        $result = $this->query( 'select * from `'.$this->dbOldPrefix.'category`;' , $this->dbOld );
        /*id 	level 	nom 	email 	login 	pass*/
        
        $this->setNewDb();
        $this->query( 'delete from `'.$this->dbNewPrefix.'categories`;' , $this->dbNew );
        $this->query( 'alter table `'.$this->dbNewPrefix.'categories` modify `name` varchar(255);' , $this->dbNew );
        
        $this->qObiect->tableName = 'categories';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
        
        while( $r = mysql_fetch_assoc($result) )
        {
            $this->qObiect->reset();
            
            $this->qObiect->add('categoryId', $r['id']);
            $this->qObiect->add('parentCategoryId', $r['root']);
            $this->qObiect->add('name', $r['name']);
            $this->qObiect->add('description', '');
            $this->qObiect->add('imageSrc', 'defaultCategoryImage.gif'); 
            $this->qObiect->add('possibleTender', $r['usable'], true);
    
            $sql = $this->qObiect->getSQL();
            $sql = iconv('ISO-8859-1','utf-8//ignore',$sql);
            $sql = str_replace("\xc2\x80", "\xe2\x82\xac", $sql); 
            $this->query( $sql , $this->dbNew );
        }
        
        return true;
    }  
    
    function convertAll()
    {
        $results = array();
                    
        try
        {
            $results['users'] = array();
            $this->init();  
            $this->convertUsers();
            
            $results['sites'] = array();
            $this->convertSites();
            
            $results['categories'] = array();  
            $this->convertCategories();
            $this->buildCategoryParents();
        }
        catch(Exception $e)
        {
            $lastKey = end(array_keys($results));
            $results[$lastKey]['error'] = $e->getMessage();
        }
        
        return $results;
    }

}
?>