<?php

class MyDirConverter extends Converter
{   
    private static $handle = null;
    
    function getInstance()
    {
        if( !self::$handle ) self::$handle = new MyDirConverter;
        return self::$handle;
    }

    function convertSites()
    {        
        $this->setOldDb();                         
        $result = $this->query( 'select * from `link`;' , $this->dbOld );
        /*id 	name 	url 	description 	state 	category 	pr*/
        
        $this->setNewDb();
        
        $this->query( 'delete from `'.$this->dbNewPrefix.'sites`;' , $this->dbNew );

        /* extra things*/
        $this->query( 'delete from `'.$this->dbNewPrefix.'votes`;' , $this->dbNew );
        $this->query( 'delete from `'.$this->dbNewPrefix.'comments`;' , $this->dbNew );
        /*             */
        
        $this->qObiect->tableName = 'sites';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
        while( $r = mysql_fetch_assoc($result) )
        {
            
                $this->qObiect->reset();
            
                $this->qObiect->add('siteId', $r['id']);
                $this->qObiect->add('categoryId', $r['category']);
                $this->qObiect->add('siteTitle', $r['name']);
                $this->qObiect->add('description', strip_tags($r['description']));
                $this->qObiect->add('url', $r['url']);
                
                switch( $r['state'] )
                {
                    case 4:
                        $status = 'validated';
                        break;
                    case 2:
                        $status = 'banned';
                        break;
                    default:
                        $status = 'waiting';                
                }
                
                $this->qObiect->add('status', $status);
                
                $this->qObiect->add('rssTitle', '');
                $this->qObiect->add('returnBond', '');
                $this->qObiect->add('rssFeedOfSite', '');

                $sql = $this->qObiect->getSQL();
                $sql = iconv('ISO-8859-1','utf-8//ignore', $sql);
                $sql = str_replace("\xc2\x80", "\xe2\x82\xac", $sql); 
                $this->query($sql , $this->dbNew);   
            
        }
        
        return true;
    }
    
    function convertEmails()
    {
        $this->setOldDb();                         
        $result = $this->query( 'select email,id_site from `validation`;' , $this->dbOld );
        /*id 	name 	url 	description 	state 	category 	pr*/
        
        $this->setNewDb();
        while( $r = mysql_fetch_assoc($result) )
        {
            $sql = 'update `'.$this->dbNewPrefix.'sites` set webmasterEmail=\''.$r['email'].'\' where siteId='.$r['id_site'].';';
            $this->query($sql , $this->dbNew);
        }
        
        return true;
    }
    
    function convertCategories()
    {        
        $this->setOldDb();                     
        $result = $this->query( 'select * from `category`;' , $this->dbOld );
        /*id 	name 	root 	usable*/
        
        $this->setNewDb();
        $this->query( 'delete from `'.$this->dbNewPrefix.'categories`;' , $this->dbNew );
        
        $this->qObiect->tableName = 'categories';
        $this->qObiect->dbPrefix = $this->dbNewPrefix;
       
        while( $r = mysql_fetch_assoc($result) )
        {
            $this->qObiect->reset();
            
            $this->qObiect->add('categoryId', $r['id']);
            $this->qObiect->add('parentCategoryId', $r['root']);
            $this->qObiect->add('name', $r['name']);
            $this->qObiect->add('description', '');
            $this->qObiect->add('imageSrc', 'defaultCategoryImage.gif');
            
            switch( $r['usable'] )
            {
                case 1:
                    $tender = 1;
                    break;
                default:
                    $tender = 0;            
            }
            $this->qObiect->add('possibleTender', $tender, true);
            
            $sql = $this->qObiect->getSQL();
            $sql = iconv('ISO-8859-1', 'utf-8//ignore', $sql);
            $sql = str_replace("\xc2\x80", "\xe2\x82\xac", $sql); 
            $this->query($sql , $this->dbNew);
        }
        
        return true;
    }

    function convertAll()
    {     
        $results = array();
                    
        try
        {
            $results['sites'] = array();
            $this->init(); 
            $this->convertSites();
            $this->convertEmails();
            
            $results['categories'] = array();  
            $this->convertCategories();
            $this->buildCategoryParents();
        }
        catch(Exception $e)
        {
            $lastKey = end(array_keys($results));
            $results[$lastKey]['error'] = $e->getMessage();
        }
        
        return $results;
    }
}
?>